﻿using KernelStructOffset;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        // KernelStructOffset
        static void Main(string[] args)
        {
            File.Delete("DisplayStruct.exe");
            File.Delete("SimpleDebugger.dll");
            File.Delete("WindowsPE.dll");

            var heapOffset = DbgOffset.Get("_HEAP");
            IntPtr pebAddress = EnvironmentBlockInfo.GetPebAddress(out IntPtr tebAddress);

            foreach (IntPtr heap in _PEB.EnumerateHeaps(pebAddress))
            {
                Console.WriteLine($"Heap: {heap.ToInt64():x}");

                if (heapOffset.TryRead<int>(heap, "Flags", out int flagsValue) == true)
                {
                    Console.WriteLine($"\tFlags: {flagsValue:x}");
                }

                if (heapOffset.TryRead<int>(heap, "ForceFlags", out int forceFlagsValue) == true)
                {
                    Console.WriteLine($"\tForceFlags: {forceFlagsValue:x}");
                }
            }

            /*
            Console.WriteLine($"TEB: {tebAddress.ToInt64():x}");
            Console.WriteLine($"PEB: {pebAddress.ToInt64():x}");
            Console.WriteLine();

            var pebOffset = DbgOffset.Get("_PEB");
            var heapOffset = DbgOffset.Get("_HEAP");

            if (pebOffset.TryRead<IntPtr>(pebAddress, "ProcessHeap", out IntPtr processHeapPtr) == false)
            {
                return;
            }

            Console.WriteLine($"Default ProcessHeap: {processHeapPtr.ToInt64():x}");

            IntPtr processHeapsPtr = pebOffset.GetPointer(pebAddress, "ProcessHeaps").ReadPtr();
            if (pebOffset.TryRead<int>(pebAddress, "NumberOfHeaps", out int numberOfHeaps) == false)
            {
                return;
            }

            Console.WriteLine($"Ptr of ProcessHeaps: {processHeapsPtr.ToInt64():x}");
            Console.WriteLine($"Number of Heaps: {numberOfHeaps}");

            for (int i = 0; i < numberOfHeaps; i++)
            {
                IntPtr entryPtr = processHeapsPtr + (IntPtr.Size * i);
                IntPtr heapAddress = entryPtr.ReadPtr();

                Console.WriteLine($"[{i}] Heap: {heapAddress.ToInt64():x}");

                if (heapOffset.TryRead<int>(heapAddress, "Flags", out int flagsValue) == true)
                {
                    Console.WriteLine($"\tFlags: {flagsValue:x}");
                }

                if (heapOffset.TryRead<int>(heapAddress, "ForceFlags", out int forceFlagsValue) == true)
                {
                    Console.WriteLine($"\tForceFlags: {forceFlagsValue:x}");
                }
            }
            */

            Console.ReadLine();
        }
    }
}
